import { DependencyFactory, DependencyInformation, FactoryOption, Key, NormalConstructor } from '../ServiceCollection';
import { ILifetime } from './ILifetime';
import { ScopeContext, ServiceProvider } from '../ServiceProvider';
export declare class ScopedLifetime<T, E> implements ILifetime<T, E> {
    private readonly factory;
    readonly name: Key<E>;
    constructor(name: Key<E>, factory: DependencyFactory<T, void, E>);
    provide(provider: ServiceProvider<E>, context: ScopeContext<E>): Partial<{ [key in keyof E]: any; }>[Key<E>];
    clone(): ILifetime<T, E>;
}
export declare function scoped<T, E>(dep: FactoryOption<T, void, E> | NormalConstructor<T, E>): DependencyInformation<T, E>;
