"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.scoped = exports.ScopedLifetime = void 0;
var Errors_1 = require("../Errors");
var ScopedLifetime = /** @class */ (function () {
    function ScopedLifetime(name, factory) {
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(ScopedLifetime.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider, context) {
            var lastSingleton = context.lastSingleton, instances = context.instances;
            if (lastSingleton)
                throw new Errors_1.SingletonScopedDependencyError(lastSingleton.name, this.name);
            if (!instances[this.name])
                instances[this.name] = this.factory(provider.createProxy(this.name, context), undefined, provider, context);
            return instances[this.name];
        }
    });
    Object.defineProperty(ScopedLifetime.prototype, "clone", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return new ScopedLifetime(this.name, this.factory);
        }
    });
    return ScopedLifetime;
}());
exports.ScopedLifetime = ScopedLifetime;
function scoped(dep) {
    return typeof dep === 'function'
        ? { lifetime: ScopedLifetime, constructor: dep }
        : __assign({ lifetime: ScopedLifetime }, dep);
}
exports.scoped = scoped;
