"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.singleton = exports.SingletonLifetime = void 0;
var SingletonLifetime = /** @class */ (function () {
    function SingletonLifetime(name, factory) {
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "isSingleton", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(SingletonLifetime.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (provider, context) {
            var instances = provider.instances;
            var proxy = provider.createProxy(this.name, context);
            if (!instances[this.name])
                instances[this.name] = this.factory(proxy, undefined, provider, context);
            return instances[this.name];
        }
    });
    Object.defineProperty(SingletonLifetime.prototype, "clone", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return new SingletonLifetime(this.name, this.factory);
        }
    });
    return SingletonLifetime;
}());
exports.SingletonLifetime = SingletonLifetime;
function singleton(dep) {
    return typeof dep === 'function'
        ? { lifetime: SingletonLifetime, constructor: dep }
        : __assign({ lifetime: SingletonLifetime }, dep);
}
exports.singleton = singleton;
