import { DependencyFactory, DependencyInformation, FactoryOption, Key, Stateful, StatefulConstructor } from '../ServiceCollection';
import { ILifetime } from './ILifetime';
import { ScopeContext, ServiceProvider } from '../ServiceProvider';
export declare class StatefulLifetime<T, P, E> implements ILifetime<Stateful<P, T>, E> {
    readonly name: Key<E>;
    private readonly factory;
    private readonly next;
    constructor(name: Key<E>, factory: DependencyFactory<T, P, E>);
    provide(provider: ServiceProvider<E>, context: ScopeContext<E>): Stateful<P, T>;
    clone(): ILifetime<Stateful<P, T>, E>;
}
export declare function stateful<T, P, E>(dep: FactoryOption<T, P, E> | StatefulConstructor<T, P, E>): DependencyInformation<Stateful<P, T>, E>;
