import { DependencyFactory, DependencyInformation, FactoryOption, Key, NormalConstructor } from '../ServiceCollection';
import { ILifetime } from './ILifetime';
import { ScopeContext, ServiceProvider } from '../ServiceProvider';
export declare class TransientLifetime<T, E> implements ILifetime<T, E> {
    readonly name: Key<E>;
    private readonly factory;
    constructor(name: Key<E>, factory: DependencyFactory<T, void, E>);
    provide(provider: ServiceProvider<E>, context: ScopeContext<E>): T;
    clone(): ILifetime<T, E>;
}
export declare function transient<T, E>(dep: FactoryOption<T, void, E> | NormalConstructor<T, E>): DependencyInformation<T, E>;
