import { ILifetime } from '../Lifetime';
import { MockStrategy, ProviderMock } from './mockUtils';
import { DependencyMap, Selector } from './types';
import { ServiceProvider } from '../ServiceProvider';
export declare class ServiceCollection<E = {}> {
    private readonly lifetimes;
    constructor(dependencies: DependencyMap<E, E>);
    get<T>(selector: Selector<T, E>): ILifetime<T, E> | undefined;
    replace(dependencies: DependencyMap<E, E>): ServiceCollection<E>;
    build(): ServiceProvider<E>;
    buildMock(mock?: MockStrategy | ProviderMock<E>, defaultMockType?: MockStrategy): ServiceProvider<E>;
}
export declare const services: <E>(dependencies: DependencyMap<E, E>) => ServiceCollection<E>;
