import { Key, LifetimeCollection, Selector } from '../ServiceCollection';
import { ILifetime } from '../Lifetime';
import { ScopeContext } from './ScopeContext';
export declare class ServiceProvider<E = any> {
    readonly lifetimes: LifetimeCollection<E>;
    readonly instances: Partial<{
        [key in keyof E]: any;
    }>;
    readonly proxy: E;
    private readonly verified;
    constructor(lifetimes: LifetimeCollection<E>);
    createProxy(key: Key<E>, context?: ScopeContext<E>): E;
    provide<T>(selector: Selector<T, E>, context?: ScopeContext<E>): T;
    enterLifetime<T>(key: Key<E>, currentContext?: ScopeContext<E>, lifetime?: ILifetime<T, E>): ScopeContext<E>;
    private createContext;
}
